/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.test.net2
{
#if NET_2_0
	using System;
	using System.Text;
	using com.db4o;
	using com.db4o.test;
	using com.db4o.query;

	class SimpleGenericType<T>
	{
		public T value;

		public SimpleGenericType(T value)
		{
			this.value = value;
		}
	}

	class Net2SimpleGenericType
	{
		public void storeOne()
		{
			Tester.store(new SimpleGenericType<string>("Will it work?"));
			Tester.store(new SimpleGenericType<int>(42));
		}

		public void test()
		{
			tstGenericType("Will it work?");
			tstGenericType(42);
		}

		private void tstGenericType<T>(T expectedValue)
		{
			Query query = Tester.query();
			query.constrain(typeof(SimpleGenericType<T>));

			ensureGenericItem<T>(expectedValue, query.execute());

			query = Tester.query();
			query.constrain(typeof(SimpleGenericType<T>));
			query.descend("value").constrain(expectedValue);
			ensureGenericItem<T>(expectedValue, query.execute());
		}

		private static void ensureGenericItem<T>(T expectedValue, ObjectSet os)
		{
			Tester.ensureEquals(1, os.size());

			SimpleGenericType<T> item = (SimpleGenericType<T>)os.next();
			Tester.ensureEquals(expectedValue, item.value);
		}
	}
#endif
}
